#include "cv.h"
#include "highgui.h"
#include <math.h>




int* cvHist(IplImage *Obr, int visible);
//vraci ukazatel na pole velikosti 256, kde kazdy prvek obsahuje cetnost daneho jasu v obraze
//provede vypocet histogramu z obrazu Obr
//promenna visible udava jestli se ma zobrazovat histogram =1 ci nikoliv =0

IplImage* cvImageAdjust(IplImage *Obr,double x1,double y1,double x2,double y2);
//provede zmenu jasu obrazu
//parametry jsou obraz, vysledek, souradnice primky, podle niz jas menime

IplImage* cvImageRotate(IplImage* Obr,int uhel,int orez);
//proved rotaci obrazu Obr o uhel uhel
//jestlize orez=0 pak bude vyseldny obraz vetsi nez vzorovy ovsem cely, jinak se obraz orizne
//na velikost originalu

int main( int argc, char** argv )
{
	IplImage *obr;
	CvMat kernel;
	IplImage *vys;
	IplImage *gray;
	float a[] = {0.111,0.111,0.111,
				 0.111,0.111,0.111,
				 0.111,0.111,0.111}; //hodnoty jadra
	float b[] = {-1,-1,-1,
				 -1,8,-1,
				 -1,-1,-1}; //hodnoty jadra
	
	
	int Hodnota=200;//nastaveni pocatecni hodnoty posuvniku
	int c;

	cvNamedWindow( "Okno",1);//vytvori okno na ktere se odkazujeme pomoci jmena
	
	cvCreateTrackbar( "Posuvnik", "Okno", &Hodnota, 1000, 0 );//vztvoreni posuvniku jeho hodnota se uklada do promenne int


	obr = cvLoadImage ( "mince.jpg",-1);//nacte obraz
	vys = cvCreateImage (cvGetSize(obr),8,1);
	
	printf("obraz se sumem\n");
	printf("**stiskni klavesu**\n");
	cvShowImage("Okno",obr);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
	cvInitMatHeader( &kernel, 3, 3, CV_32FC1, a, CV_AUTOSTEP );//vytvoreni hodnot jadra
	
	//konvoluce masky a obrazu
	cvFilter2D(obr,vys,&kernel,cvPoint(-1,-1));//aplikace jadra kernel na cely obraz
	//treti parametr je samotne jadro, posledni parametr je stred jadra (-1 -1 je stred)
	printf("odstraneni sumu pomoci konvoluce\n");
	printf("**stiskni klavesu**\n");
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	

	//aplikace medianu
	printf("odstraneni sumu pomoci medianu\n");
	printf("**stiskni klavesu**\n");
	cvSmooth(obr,vys,CV_MEDIAN,3,0,0);//provede filtraci medianem,
	//filtrovane okoli je 3*3, dalsi parametry slouzi k nastaveni jinych filtru viz. help
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
	cvReleaseImage(&obr);//uvolneni pameti
	cvReleaseImage(&vys);//uvolneni pameti

	obr = cvLoadImage ( "s2.jpg",-1);//nacte obraz
	gray = cvCreateImage ( cvGetSize(obr), 8, 1);// vztvoreni hlavycky obrazu a alokovani pameti 
	cvCvtColor( obr, gray, CV_BGR2GRAY);

	vys = cvCreateImage (cvGetSize(obr),IPL_DEPTH_16S,1);
	printf("\n");
	printf("**stiskni klavesu**\n");
	cvShowImage("Okno",gray);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekund
    
	//gradientni operator
	printf("prvni derivace obrazu ve smeru x a y\n");
	printf("**stiskni klavesu**\n");
	cvSobel(gray,vys,0,0,3);//pocita prvni druhou nebo treti derivaci ve smeru x, y nebo obojim
	//stupni obraz, vysledek, derivace v x, derivace v y, velikost elementu
	
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekund
	cvReleaseImage(&vys);//uvolneni pameti


	vys = cvCreateImage (cvGetSize(obr),8,1);

	//detekce hran
	printf("detekce hran pomoci cannyho\n");
	printf("**stiskni klavesu**\n");
	cvCanny(gray,vys,50,300,3);//provede nalezeni hran v obraze
	//vstupni obraz, vesledek, prah1 , prah2, velikost elementu
	//vetsi y prahu se pouzije pro nalezeni hran vetsich nez tento prah
	//nensi prah se pouzije pro doplneni techto hran
	//je treba vyzkouset
    cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekund

	
	//nalezeni bodu v obraze
	printf("detekce bodu v obraze\n");
	printf("**stiskni klavesu**\n");
	cvInitMatHeader( &kernel, 3, 3, CV_32FC1, b, CV_AUTOSTEP );//vytvoreni hodnot jadra


	cvFilter2D(gray,vys,&kernel,cvPoint(-1,-1));//aplikace jadra kernel na cely obraz
	//treti parametr je samotne jadro, posledni parametr je stred jadra (-1 -1 je stred)
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekund
	


    cvDestroyWindow("Okno");//uvolneni okna    
	cvReleaseImage(&obr);//uvolneni pameti
	cvReleaseImage(&vys);//uvolneni pameti
	cvReleaseImage(&gray);//uvolneni pameti



    return 0;
}




int* cvHist(IplImage *Obr, int visible)
//vypocet histogramu
{
	int i,j,max=0;
	int *Hist;//pole pro umisteni hodnot histogramu
	IplImage *Histogram;
	int range=256;//pocet jasu
	int c;

	//alokace pameti pro histogram a jeho vynulovani
	Hist = (int*) malloc(sizeof(int)*range);
	for (i=0;i<range;i++){
		Hist[i]=0;//vynulovani histgramu
	}


	for (i=0;i<Obr->height;i++){
		for (j=0;j<Obr->width;j++){
			Hist[(unsigned char)Obr->imageData[j+i*Obr->width]]++;//inkrementace prislusneho jasu
		}
	}

	if (visible==1){
		cvNamedWindow( "Histogram", 1 );
		for (i=0;i<=range;i++){
			if (max<Hist[i]){
				max=Hist[i];
			}
		}
		Histogram= cvCreateImage( cvSize(range,300),8,1);//vytvori obraz pro zobrazeni histogramu 300 cely histogram se musi max/300
		for (i=0;i<=range;i++){
			cvLine(Histogram,cvPoint(i,(int)(300-Hist[i]/((float)max/300))),cvPoint(i,300),cvRealScalar(255),0,8,0);
			cvLine(Histogram,cvPoint(i,(int)(300-Hist[i]/((float)max/300))),cvPoint(i,0),cvRealScalar(0),0,8,0);
		}
		cvShowImage( "Histogram", Histogram);
		c = cvWaitKey(0);//cekani na klavesu v milisekundach
		cvDestroyWindow("Histogram");
		cvReleaseImage(&Histogram);
	}
	return(Hist);
}

IplImage* cvImageAdjust(IplImage *Obr, double x1,double y1,double x2,double y2)
{
	double k,q;//parametry primky
	int pole[256];//prepocet hodnot
	int i,j;
	IplImage *Vys;

	Vys = cvCreateImage( cvGetSize(Obr),8,Obr->nChannels);
	k=(y2-y1)/(x2-x1);
	q=y1-k*x1;
	for (i=0;i<256;i++){
		if (k*i/256+q<0){
			pole[i]=(unsigned char)0;
		}
		else{
			if (k*i/256+q>1){
				pole[i]=(unsigned char)255;
			}
			else{
				pole[i]=(unsigned char)(1+(k*i/256+q)*255);
			}
		}
	}
	for (i=0;i<Obr->widthStep;i++){
		for (j=0;j<Obr->height;j++){
			Vys->imageData[j*Obr->widthStep+i]=pole[(unsigned char)Obr->imageData[j*Obr->widthStep+i]];
		}
	}
	return (Vys);
}

IplImage* cvImageRotate(IplImage* Obr,int uhel,int orez)
{
	float m[6];
    CvMat M = cvMat( 2, 3, CV_32F, m );
    double prep;
	int vyska;
	int sirka;
	double uhelpom;
	IplImage *Vys;
	 
	
	if (orez==0){//obraz se zvetsi
		uhelpom=atan((double)(Obr->height/2)/(double)(Obr->width/2));//vypocita se pomocny uhel 
		prep=sqrt(Obr->width*Obr->width+Obr->height*Obr->height)/2;
		if (sin(uhelpom+uhel*CV_PI/180.)*prep>sin(uhelpom-uhel*CV_PI/180.)*prep){
			vyska=sin(uhelpom+uhel*CV_PI/180.)*prep;
		}
		else{
			vyska=sin(uhelpom-uhel*CV_PI/180.)*prep;
		}
		if (cos(uhelpom+uhel*CV_PI/180.)*prep>cos(uhelpom-uhel*CV_PI/180.)*prep){
			sirka=cos(uhelpom+uhel*CV_PI/180.)*prep;
		}
		else{
			sirka=cos(uhelpom-uhel*CV_PI/180.)*prep;
		}
		Vys= cvCreateImage( cvSize(sirka*2,vyska*2),8,Obr->nChannels);//vytvoreni vysledneho obrazu
	}
	else{
		Vys= cvCloneImage( Obr);//vytvoreni vysledneho obrazu
	}
	m[0] = (float)(cos(-uhel*CV_PI/180.));
    m[1] = (float)(sin(-uhel*CV_PI/180.));
    m[2] = Obr->width*0.5f;
    m[3] = -m[1];
    m[4] = m[0];
    m[5] = Obr->height*0.5f;

	

    cvGetQuadrangleSubPix( Obr, Vys, &M, 1, cvScalarAll(0));//provede se rotace
	
    return(Vys);
}

